Module:    make-x-sockets
Synopsis:  Create the x-sockets library
Author:    Chris Double
Copyright: (C) 2000, Chris Double.  All rights reserved.
License:   See License.txt

define method do-patch(source, dest, patch)
  local method copy-source-files()
    let files = #["abstract-sockets.dylan",
                  "client-sockets.dylan",
                  "internet-address.dylan",
                  "server-sockets.dylan",
                  "socket-conditions.dylan",
                  "udp-sockets.dylan",
                  "win32-socket-accessor.dylan",
                  "win32-socket-cleanup.dylan",
                  "wsa-error-codes.dylan"];

    for(file in files)
      let s = concatenate(source, "\\", file);
      let d = concatenate(dest, "\\", file);
      format-out("Copying %s to %s\n", s, d);
      copy-file(s, d);      
    end for;
  end method;

  local method copy-patch-files()
    let files = #["x-sockets.hdp",
                  "readme.txt",
                  "library.dylan",
                  "tcp-sockets.dylan",
                  "win32-tcp-socket-accessor.dylan"];

    for(file in files)
      let s = concatenate(patch, "\\", file);
      let d = concatenate(dest, "\\", file);
      format-out("Copying %s to %s\n", s, d);
      copy-file(s, d);      
    end for;
  end method;

  format-out("Patching: %s and %s to %s\n", source, patch, dest);
  copy-source-files();
  copy-patch-files();
  
end method do-patch;


