Module:    Dylan-user	
Author:    Toby
Synopsis:  New sockets library
Copyright: Copyright (c) 1998-2000 Functional Objects, Inc. All rights reserved.


define library x-sockets
  use functional-dylan;
  use C-FFI; // don't use any defining macros, put them in winsock-extensions;
  use machine-word;
  use WinSock2;
  use streams;
  use format;
  use format-out;
  use byte-vector;
  export sockets;
  export sockets-internals;
end library;

define module sockets
  create start-sockets;
  create
    <abstract-socket>,
       local-host, local-port, socket-descriptor, close-socket, socket-open?,
       <server-socket>,
         accept, server-class-for-protocol, with-server-socket, start-server,
         <TCP-server-socket>,
         <UDP-server-socket>,
      <socket>, // client socket
        remote-host, remote-port, with-socket,
        <buffered-socket>,
          <TCP-socket>,
          <UDP-socket>;
  create
    \with-socket-thread,
    invoke-with-socket-thread,
    register-socket-thread,
    unregister-socket-thread;				      
  create
    <internet-address>,
      <ipv4-address>,
        host-name, host-address, numeric-host-address, all-addresses,
        aliases, $loopback-address, $local-host;
  create
    <numeric-address>,
      network-order, host-order,
      <ipv4-numeric-address>,
        <ipv4-network-order-address>, <ipv4-host-order-address>;
  create
    <socket-condition>,
      <socket-warning>,
      <socket-error>,
        <internal-socket-error>, <sockets-not-initialized>,
      <recoverable-socket-condition>,
        <blocking-call-interrupted>, <out-of-resources>,
        <network-not-responding>, <invalid-address>, <host-not-found>,
        <server-not-responding>, <socket-closed>, <connection-failed>,
        <connection-closed>, <address-in-use>, <host-unreachable>,
        <service-not-found>,
      <socket-accessor-error>,
        <win32-socket-error>,
          WSA-numeric-error-code, WSA-symbolic-error-code, explanation,
          calling-function;
  // temporary exports for debugging
  // create
  //   *winsock-started*, *closing-thread*, accessor-close-socket,
  //   accessor-cleanup, accessor-startup;
  use functional-dylan, export: { as };
end module sockets;

define module sockets-internals
  use functional-dylan;
  use dylan-extensions;
  use machine-integer-user;
  // TO DO: figure out import list for c-ffi, no defining macros
  use C-FFI;
  use threads;
  use dylan-direct-c-ffi;
  // TO DO: figure out correct export list for streams
  use streams, export: all; // not really.  Won't hurt for now
  use streams-internals;
  use format;
  use format-out;
  use byte-vector;
  use WinSock2, // from "winsock2.h":
    rename: {socket => win32-socket,
             connect => win32-connect, 
	     bind => win32-bind,
             listen => win32-listen,
	     accept => win32-accept,
	     htonl => win32-htonl, ntohl => win32-ntohl,
	     htons => win32-htons, ntohs => win32-ntohs,
	     gethostbyname => win32-gethostbyname, 
	     getservbyname => win32-getservbyname, 
	     gethostbyaddr => win32-gethostbyaddr,
	     getsockname => win32-getsockname,
	     getpeername => win32-getpeername,
	     gethostname => win32-gethostname, 
	     <c-socket> => <win32-socket-descriptor>,
	     closesocket => win32-closesocket},
    exclude: {<socket>, // use <accessor-socket-descriptor>
	      send,  //  use win32-send-buffer instead
	      recv};  //  use win32-recv-buffer instead

  use sockets, export: all;
  create 
    <general-TCP-socket>, <byte-char-TCP-socket>, <byte-TCP-socket>;

  create
    <general-UDP-socket>, <byte-char-UDP-socket>, <byte-UDP-socket>,
    <socket-accessor>, <win32-tcp-accessor>, client-class-for-protocol,
    type-for-socket, client-class-for-element-type, raw-accessor-write, raw-accessor-read;
end module;
